/*
                     This file is part of the Opie Project
             =.             (C) 2005 Michael 'Mickey' Lauer <mickey@Vanille.de>
            .=l.
     .>+-=
_;:,   .>  :=|.         This program is free software; you can
.> <`_,  > .  <=          redistribute it and/or  modify it under
:`=1 )Y*s>-.--  :           the terms of the GNU Library General Public
.="- .-=="i,   .._         License as published by the Free Software
- .  .-<_>   .<>         Foundation; either version 2 of the License,
  ._= =}    :          or (at your option) any later version.
  .%`+i>    _;_.
  .i_,=:_.   -<s.       This program is distributed in the hope that
  + . -:.    =       it will be useful,  but WITHOUT ANY WARRANTY;
  : ..  .:,   . . .    without even the implied warranty of
  =_    +   =;=|`    MERCHANTABILITY or FITNESS FOR A
 _.=:.    :  :=>`:     PARTICULAR PURPOSE. See the GNU
..}^=.=    =    ;      Library General Public License for more
++=  -.   .`   .:       details.
:   = ...= . :.=-
-.  .:....=;==+<;          You should have received a copy of the GNU
 -_. . .  )=. =           Library General Public License along with
  --    :-=`           this library; see the file COPYING.LIB.
                             If not, write to the Free Software Foundation,
                             Inc., 59 Temple Place - Suite 330,
                             Boston, MA 02111-1307, USA.

*/

#ifndef CONFIGDIALOG_H
#define CONFIGDIALOG_H

#include "configdialogbase.h"

namespace Opie { namespace Core { class OPcmciaSocket; class OConfig; }; };

typedef QMap<QString,QString> StringMap;

class ConfigDialog : public ConfigDialogBase
{
  Q_OBJECT
  public:
    ConfigDialog( const Opie::Core::OPcmciaSocket* card, QWidget* parent );
    ~ConfigDialog();
    static QString preferredAction( const Opie::Core::OPcmciaSocket* card, const QString& type );
    static QString readConfigEntry( const Opie::Core::OPcmciaSocket* card, const QString& key, const QString& defaultValue );
    static void writeConfigEntry( const Opie::Core::OPcmciaSocket* card, const QString& key, const QString& value );
    static Opie::Core::OConfig* cardConfig( const Opie::Core::OPcmciaSocket* card );
    void writeConfiguration( const Opie::Core::OPcmciaSocket* card );
    StringMap bindEntries;
};

#endif
